diff -ruN vdr-1.7.37/pat.h vdr-1.7.38/pat.h
--- vdr-1.7.37/pat.h	2011-12-04 14:38:17.000000000 +0100
+++ vdr-1.7.38/pat.h	2013-02-16 16:20:24.000000000 +0100
@@ -4,7 +4,7 @@
  * See the main source file 'vdr.c' for copyright information and
  * how to reach the author.
  *
- * $Id: pat.h 2.2 2011/12/04 13:38:17 kls Exp $
+ * $Id: pat.h 2.3 2013/02/16 15:20:24 kls Exp $
  */
 
 #ifndef __PAT_H
@@ -37,7 +37,7 @@
          ///< Copies all available CA descriptors for the given Source, Transponder and ServiceId
          ///< into the provided buffer at Data (at most BufSize bytes). Only those CA descriptors
          ///< are copied that match one of the given CA system IDs.
-         ///< \return Returns the number of bytes copied into Data (0 if no CA descriptors are
+         ///< Returns the number of bytes copied into Data (0 if no CA descriptors are
          ///< available), or -1 if BufSize was too small to hold all CA descriptors.
          ///< The return value tells whether these CA descriptors are to be used
          ///< for the individual streams.
diff -ruN vdr-1.7.37/recording.c vdr-1.7.38/recording.c
--- vdr-1.7.37/recording.c	2013-02-08 10:02:07.000000000 +0100
+++ vdr-1.7.38/recording.c	2013-02-17 14:17:55.000000000 +0100
@@ -4,7 +4,7 @@
  * See the main source file 'vdr.c' for copyright information and
  * how to reach the author.
  *
- * $Id: recording.c 2.86 2013/02/08 09:02:07 kls Exp $
+ * $Id: recording.c 2.88 2013/02/17 13:17:55 kls Exp $
  */
 
 #include "recording.h"
@@ -1103,7 +1103,7 @@
   return true;
 }
 
-void cRecording::SetStartTime(time_t Start) 
+void cRecording::SetStartTime(time_t Start)
 {
   start = Start;
   free(fileName);
@@ -1506,6 +1506,15 @@
   return false;
 }
 
+bool cMarks::Save(void)
+{
+  if (cConfig<cMark>::Save()) {
+     lastFileTime = LastModifiedTime(fileName);
+     return true;
+     }
+  return false;
+}
+
 void cMarks::Align(void)
 {
   cIndexFile IndexFile(recordingFileName, false, isPesRecording);
@@ -2127,7 +2136,7 @@
   return -1;
 }
 
-bool GenerateIndex(const char *FileName) 
+bool GenerateIndex(const char *FileName)
 {
   if (DirectoryOk(FileName)) {
      cRecording Recording(FileName);
diff -ruN vdr-1.7.37/recording.h vdr-1.7.38/recording.h
--- vdr-1.7.37/recording.h	2013-02-07 14:42:17.000000000 +0100
+++ vdr-1.7.38/recording.h	2013-02-14 16:13:14.000000000 +0100
@@ -4,7 +4,7 @@
  * See the main source file 'vdr.c' for copyright information and
  * how to reach the author.
  *
- * $Id: recording.h 2.42 2013/02/07 13:42:17 kls Exp $
+ * $Id: recording.h 2.44 2013/02/14 15:13:14 kls Exp $
  */
 
 #ifndef __RECORDING_H
@@ -19,8 +19,6 @@
 #include "tools.h"
 
 #define FOLDERDELIMCHAR '~'
-#define TIMERMACRO_TITLE    "TITLE"
-#define TIMERMACRO_EPISODE  "EPISODE"
 
 extern int DirectoryPathMax;
 extern int DirectoryNameMax;
@@ -234,6 +232,7 @@
 public:
   bool Load(const char *RecordingFileName, double FramesPerSecond = DEFAULTFRAMESPERSECOND, bool IsPesRecording = false);
   bool Update(void);
+  bool Save(void);
   void Align(void);
   void Sort(void);
   void Add(int Position);
diff -ruN vdr-1.7.37/remux.c vdr-1.7.38/remux.c
--- vdr-1.7.37/remux.c	2012-11-25 15:16:11.000000000 +0100
+++ vdr-1.7.38/remux.c	2013-02-17 14:17:58.000000000 +0100
@@ -4,7 +4,7 @@
  * See the main source file 'vdr.c' for copyright information and
  * how to reach the author.
  *
- * $Id: remux.c 2.73 2012/11/25 14:16:11 kls Exp $
+ * $Id: remux.c 2.74 2013/02/17 13:17:58 kls Exp $
  */
 
 #include "remux.h"
@@ -1244,7 +1244,7 @@
                                          break;
            case nutCodedSliceNonIdr:
            case nutCodedSliceIdr:        if (gotAccessUnitDelimiter && gotSequenceParameterSet) {
-                                            ParseSliceHeader(); 
+                                            ParseSliceHeader();
                                             gotAccessUnitDelimiter = false;
                                             return tsPayload.Used();
                                             }
diff -ruN vdr-1.7.37/ringbuffer.h vdr-1.7.38/ringbuffer.h
--- vdr-1.7.37/ringbuffer.h	2012-09-20 11:29:32.000000000 +0200
+++ vdr-1.7.38/ringbuffer.h	2013-02-16 16:20:37.000000000 +0100
@@ -4,7 +4,7 @@
  * See the main source file 'vdr.c' for copyright information and
  * how to reach the author.
  *
- * $Id: ringbuffer.h 2.4 2012/09/20 09:29:32 kls Exp $
+ * $Id: ringbuffer.h 2.5 2013/02/16 15:20:37 kls Exp $
  */
 
 #ifndef __RINGBUFFER_H
@@ -84,17 +84,17 @@
     ///< Reads at most Max bytes from FileHandle and stores them in the
     ///< ring buffer. If Max is 0, reads as many bytes as possible.
     ///< Only one actual read() call is done.
-    ///< \return Returns the number of bytes actually read and stored, or
+    ///< Returns the number of bytes actually read and stored, or
     ///< an error value from the actual read() call.
   int Read(cUnbufferedFile *File, int Max = 0);
     ///< Like Read(int FileHandle, int Max), but reads from a cUnbufferedFile).
   int Put(const uchar *Data, int Count);
     ///< Puts at most Count bytes of Data into the ring buffer.
-    ///< \return Returns the number of bytes actually stored.
+    ///< Returns the number of bytes actually stored.
   uchar *Get(int &Count);
     ///< Gets data from the ring buffer.
     ///< The data will remain in the buffer until a call to Del() deletes it.
-    ///< \return Returns a pointer to the data, and stores the number of bytes
+    ///< Returns a pointer to the data, and stores the number of bytes
     ///< actually available in Count. If the returned pointer is NULL, Count has no meaning.
   void Del(int Count);
     ///< Deletes at most Count bytes from the ring buffer.
diff -ruN vdr-1.7.37/skinlcars.c vdr-1.7.38/skinlcars.c
--- vdr-1.7.37/skinlcars.c	2013-01-25 15:54:11.000000000 +0100
+++ vdr-1.7.38/skinlcars.c	2013-02-15 16:08:02.000000000 +0100
@@ -4,7 +4,7 @@
  * See the main source file 'vdr.c' for copyright information and
  * how to reach the author.
  *
- * $Id: skinlcars.c 2.18 2013/01/25 14:54:11 kls Exp $
+ * $Id: skinlcars.c 2.19 2013/02/15 15:08:02 kls Exp $
  */
 
 // "Star Trek: The Next Generation"(R) is a registered trademark of Paramount Pictures,
@@ -1136,7 +1136,7 @@
   // The timer data:
   bool Alert = !Timer->Recording() && Timer->Pending();
   tColor ColorFg = Alert ? Theme.Color(clrAlertFg) : Theme.Color(clrTimerFg);
-  tColor ColorBg = Alert ? Theme.Color(clrAlertFg) : Theme.Color(clrTimerBg);
+  tColor ColorBg = Alert ? Theme.Color(clrAlertBg) : Theme.Color(clrTimerBg);
   osd->DrawRectangle(xs00, y, xs03 - 1, y + lineHeight - 1, ColorBg);
   cString Date;
   if (Timer->Recording())
diff -ruN vdr-1.7.37/svdrp.c vdr-1.7.38/svdrp.c
--- vdr-1.7.37/svdrp.c	2013-01-17 16:19:02.000000000 +0100
+++ vdr-1.7.38/svdrp.c	2013-02-17 14:18:01.000000000 +0100
@@ -10,7 +10,7 @@
  * and interact with the Video Disk Recorder - or write a full featured
  * graphical interface that sits on top of an SVDRP connection.
  *
- * $Id: svdrp.c 2.23 2013/01/17 15:19:02 kls Exp $
+ * $Id: svdrp.c 2.24 2013/02/17 13:18:01 kls Exp $
  */
 
 #include "svdrp.h"
@@ -1512,7 +1512,7 @@
      else
         Reply(501, "Cannot open file \"%s\"", Option);
      }
-  else {     
+  else {
      delete PUTEhandler;
      PUTEhandler = new cPUTEhandler;
      Reply(PUTEhandler->Status(), "%s", PUTEhandler->Message());
diff -ruN vdr-1.7.37/thread.h vdr-1.7.38/thread.h
--- vdr-1.7.37/thread.h	2012-10-04 14:15:39.000000000 +0200
+++ vdr-1.7.38/thread.h	2013-02-16 16:20:44.000000000 +0100
@@ -4,7 +4,7 @@
  * See the main source file 'vdr.c' for copyright information and
  * how to reach the author.
  *
- * $Id: thread.h 2.3 2012/10/04 12:15:39 kls Exp $
+ * $Id: thread.h 2.4 2013/02/16 15:20:44 kls Exp $
  */
 
 #ifndef __THREAD_H
@@ -31,7 +31,7 @@
   bool Wait(int TimeoutMs = 0);
        ///< Waits at most TimeoutMs milliseconds for a call to Signal(), or
        ///< forever if TimeoutMs is 0.
-       ///< \return Returns true if Signal() has been called, false it the given
+       ///< Returns true if Signal() has been called, false it the given
        ///< timeout has expired.
   void Signal(void);
        ///< Signals a caller of Wait() that the condition it is waiting for is met.
diff -ruN vdr-1.7.37/tools.h vdr-1.7.38/tools.h
--- vdr-1.7.37/tools.h	2012-12-06 09:59:39.000000000 +0100
+++ vdr-1.7.38/tools.h	2013-02-17 14:18:06.000000000 +0100
@@ -4,7 +4,7 @@
  * See the main source file 'vdr.c' for copyright information and
  * how to reach the author.
  *
- * $Id: tools.h 2.23 2012/12/06 08:59:39 kls Exp $
+ * $Id: tools.h 2.24 2013/02/17 13:18:06 kls Exp $
  */
 
 #ifndef __TOOLS_H
@@ -45,7 +45,7 @@
 
 #define MALLOC(type, size)  (type *)malloc(sizeof(type) * (size))
 
-template<class T> inline void DELETENULL(T *&p) { T *q = p; p = NULL; delete q; } 
+template<class T> inline void DELETENULL(T *&p) { T *q = p; p = NULL; delete q; }
 
 #define CHECK(s) { if ((s) < 0) LOG_ERROR; } // used for 'ioctl()' calls
 #define FATALERRNO (errno && errno != EAGAIN && errno != EINTR)
diff -ruN vdr-1.7.37/vdr.c vdr-1.7.38/vdr.c
--- vdr-1.7.37/vdr.c	2013-02-08 11:47:02.000000000 +0100
+++ vdr-1.7.38/vdr.c	2013-02-14 11:49:06.000000000 +0100
@@ -22,7 +22,7 @@
  *
  * The project's page is at http://www.tvdr.de
  *
- * $Id: vdr.c 2.48 2013/02/08 10:47:02 kls Exp $
+ * $Id: vdr.c 2.49 2013/02/14 10:49:06 kls Exp $
  */
 
 #include <getopt.h>
@@ -834,22 +834,26 @@
         time_t Now = time(NULL);
 
         // Make sure we have a visible programme in case device usage has changed:
-        if (!EITScanner.Active() && cDevice::PrimaryDevice()->HasDecoder() && !cDevice::PrimaryDevice()->HasProgramme()) {
+        if (!EITScanner.Active() && cDevice::PrimaryDevice()->HasDecoder()) {
            static time_t lastTime = 0;
-           if (!CamMenuActive() && Now - lastTime > MINCHANNELWAIT) { // !CamMenuActive() to avoid interfering with the CAM if a CAM menu is open
-              cChannel *Channel = Channels.GetByNumber(cDevice::CurrentChannel());
-              if (Channel && (Channel->Vpid() || Channel->Apid(0) || Channel->Dpid(0))) {
-                 if (cDevice::GetDeviceForTransponder(Channel, LIVEPRIORITY) && Channels.SwitchTo(Channel->Number())) // try to switch to the original channel...
-                    ;
-                 else if (LastTimerChannel > 0) {
-                    Channel = Channels.GetByNumber(LastTimerChannel);
-                    if (Channel && cDevice::GetDeviceForTransponder(Channel, LIVEPRIORITY) && Channels.SwitchTo(LastTimerChannel)) // ...or the one used by the last timer
+           if (!cDevice::PrimaryDevice()->HasProgramme()) {
+              if (!CamMenuActive() && Now - lastTime > MINCHANNELWAIT) { // !CamMenuActive() to avoid interfering with the CAM if a CAM menu is open
+                 cChannel *Channel = Channels.GetByNumber(cDevice::CurrentChannel());
+                 if (Channel && (Channel->Vpid() || Channel->Apid(0) || Channel->Dpid(0))) {
+                    if (cDevice::GetDeviceForTransponder(Channel, LIVEPRIORITY) && Channels.SwitchTo(Channel->Number())) // try to switch to the original channel...
                        ;
+                    else if (LastTimerChannel > 0) {
+                       Channel = Channels.GetByNumber(LastTimerChannel);
+                       if (Channel && cDevice::GetDeviceForTransponder(Channel, LIVEPRIORITY) && Channels.SwitchTo(LastTimerChannel)) // ...or the one used by the last timer
+                          ;
+                       }
                     }
+                 lastTime = Now; // don't do this too often
+                 LastTimerChannel = -1;
                  }
-              lastTime = Now; // don't do this too often
-              LastTimerChannel = -1;
               }
+           else
+              lastTime = 0; // makes sure we immediately try again next time
            }
         // Update the OSD size:
         {
